/**
 * @class tabbar
 * @extends view
 * Presents a bar of configurable tabs.  [example](http://localhost:2000/examples/tabbar).
 * <br/><a href="/examples/tabs">examples &raquo;</a>
 * 
 * <iframe style="border:0;width:900px;height:600px" src="/apps/docs/example#path=$ui/tabbar.js"></iframe>
 * <a target="blank" href="/apps/docs/example#path=$ui/tabbar.js">open example in new tab &raquo;</a>
 * 
 */
/**
 * @attribute {Array} [tabs=""]
 * Tab definitions.  This can be a simple list of strings or and array of more complicated
 * objects that describe tab behavior in detail.
 */
/**
 * @attribute {vec4} [tabcolor="0,0,0,1"]
 * Color of default tabs, can be overridden in style
 */
/**
 * @attribute {float32} [activetab="0"]
 * Current tab selection
 */