Ext.data.JsonP.dataset({"tagname":"class","name":"dataset","autodetected":{},"files":[{"filename":"dataset.js","href":"dataset.html#dataset"}],"extends":"node","members":[{"name":"addListener","tagname":"method","owner":"node","id":"method-addListener","meta":{}},{"name":"find","tagname":"method","owner":"node","id":"method-find","meta":{}},{"name":"findChild","tagname":"method","owner":"node","id":"method-findChild","meta":{}},{"name":"fork","tagname":"method","owner":"dataset","id":"method-fork","meta":{}},{"name":"mixin","tagname":"method","owner":"node","id":"method-mixin","meta":{}},{"name":"parse","tagname":"method","owner":"dataset","id":"method-parse","meta":{}},{"name":"redo","tagname":"method","owner":"dataset","id":"method-redo","meta":{}},{"name":"removeListener","tagname":"method","owner":"node","id":"method-removeListener","meta":{}},{"name":"stringify","tagname":"method","owner":"dataset","id":"method-stringify","meta":{}},{"name":"undo","tagname":"method","owner":"dataset","id":"method-undo","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-dataset","short_doc":"The dataset class allows you to share a single \"document\" between various parts of your application. ...","classIcon":"icon-class","superclasses":["node"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/node' rel='node' class='docClass'>node</a><div class='subclass '><strong>dataset</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/dataset.html#dataset' target='_blank'>dataset.js</a></div></pre><div class='doc-contents'><p>The dataset class allows you to share a single \"document\" between various parts of your application.\nThe dataset provides undo/redo functionality by serializing its contents to a JSON string.\nTo modify a dataset you need to use the \"fork\" method. The fork method saves the current instance to the undo stack, calls back to your code and then notifies all objects that have this dataset instance bound to them to update themselves.</p>\n\n<iframe style=\"border:0;width:900px;height:300px\" src=\"/apps/docs/example#path=$server/dataset.js\"></iframe>\n\n\n<p><a target=\"blank\" href=\"/apps/docs/example#path=$server/dataset.js\">open example in new tab &raquo;</a></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addListener' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-addListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-addListener' class='name expandable'>addListener</a>( <span class='pre'>key, cb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>add a listener to an attribute ...</div><div class='long'><p>add a listener to an attribute</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>cb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-find' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-find' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-find' class='name expandable'>find</a>( <span class='pre'>name</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds a parent node by name. ...</div><div class='long'><p>Finds a parent node by name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-findChild' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-findChild' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-findChild' class='name expandable'>findChild</a>( <span class='pre'>name</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds a child node by name. ...</div><div class='long'><p>Finds a child node by name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-fork' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='dataset'>dataset</span><br/><a href='source/dataset.html#dataset-method-fork' target='_blank' class='view-source'>view source</a></div><a href='#!/api/dataset-method-fork' class='name expandable'>fork</a>( <span class='pre'>callback</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Fork starts a new modification on a dataset; ...</div><div class='long'><p>Fork starts a new modification on a dataset;</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>callback</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-mixin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-mixin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-mixin' class='name expandable'>mixin</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Mixes in another class or object, just pass in any number of object or class references. ...</div><div class='long'><p>Mixes in another class or object, just pass in any number of object or class references. They are copied on key by key</p>\n</div></div></div><div id='method-parse' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='dataset'>dataset</span><br/><a href='source/dataset.html#dataset-method-parse' target='_blank' class='view-source'>view source</a></div><a href='#!/api/dataset-method-parse' class='name expandable'>parse</a>( <span class='pre'>stringdata</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>convert a string in to a meaningful javascript object for this dataset. ...</div><div class='long'><p>convert a string in to a meaningful javascript object for this dataset. The default is JSON, but you could use this function to accept any format of choice.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>stringdata</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-redo' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='dataset'>dataset</span><br/><a href='source/dataset.html#dataset-method-redo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/dataset-method-redo' class='name expandable'>redo</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Go forward to the next state. ...</div><div class='long'><p>Go forward to the next state. All classes that have this dataset bound will get their assignment updated</p>\n</div></div></div><div id='method-removeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-removeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-removeListener' class='name expandable'>removeListener</a>( <span class='pre'>key, cb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>remove a listener from an attribute, uses the actual function reference to find it\nif you dont pass in a function ref...</div><div class='long'><p>remove a listener from an attribute, uses the actual function reference to find it\nif you dont pass in a function reference it removes all listeners</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>cb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-stringify' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='dataset'>dataset</span><br/><a href='source/dataset.html#dataset-method-stringify' target='_blank' class='view-source'>view source</a></div><a href='#!/api/dataset-method-stringify' class='name expandable'>stringify</a>( <span class='pre'>data</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>convert an object in to a string. ...</div><div class='long'><p>convert an object in to a string. Defaults to standard JSON, but you could overload this function to provide a more efficient fileformat. Do not forget to convert the JSONParse function as well.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>data</span> : Object<div class='sub-desc'><p>Object</p>\n</div></li></ul></div></div></div><div id='method-undo' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='dataset'>dataset</span><br/><a href='source/dataset.html#dataset-method-undo' target='_blank' class='view-source'>view source</a></div><a href='#!/api/dataset-method-undo' class='name expandable'>undo</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Go back to the previous state. ...</div><div class='long'><p>Go back to the previous state. All classes that have this dataset bound will get their assignment updated</p>\n</div></div></div></div></div></div></div>","meta":{}});