Ext.data.JsonP.gyroscope({"tagname":"class","name":"gyroscope","autodetected":{},"files":[{"filename":"gyroscope.js","href":"gyroscope.html#gyroscope"}],"extends":"node","members":[{"name":"accuracy","tagname":"attribute","owner":"gyroscope","id":"attribute-accuracy","meta":{}},{"name":"alpha","tagname":"attribute","owner":"gyroscope","id":"attribute-alpha","meta":{}},{"name":"beta","tagname":"attribute","owner":"gyroscope","id":"attribute-beta","meta":{}},{"name":"compass","tagname":"attribute","owner":"gyroscope","id":"attribute-compass","meta":{}},{"name":"gamma","tagname":"attribute","owner":"gyroscope","id":"attribute-gamma","meta":{}},{"name":"orientation","tagname":"attribute","owner":"gyroscope","id":"attribute-orientation","meta":{}},{"name":"supported","tagname":"attribute","owner":"gyroscope","id":"attribute-supported","meta":{}},{"name":"addListener","tagname":"method","owner":"node","id":"method-addListener","meta":{}},{"name":"find","tagname":"method","owner":"node","id":"method-find","meta":{}},{"name":"findChild","tagname":"method","owner":"node","id":"method-findChild","meta":{}},{"name":"mixin","tagname":"method","owner":"node","id":"method-mixin","meta":{}},{"name":"removeListener","tagname":"method","owner":"node","id":"method-removeListener","meta":{}}],"alternateClassNames":[],"aliases":{},"id":"class-gyroscope","short_doc":"The gyro receives gyroscope and compass data where available. ...","classIcon":"icon-class","superclasses":["node"],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><pre class=\"hierarchy\"><h4>Hierarchy</h4><div class='subclass first-child'><a href='#!/api/node' rel='node' class='docClass'>node</a><div class='subclass '><strong>gyroscope</strong></div></div><h4>Files</h4><div class='dependency'><a href='source/gyroscope.html#gyroscope' target='_blank'>gyroscope.js</a></div></pre><div class='doc-contents'><p>The gyro receives gyroscope and compass data where available.\nSee <a href=\"https://w3c.github.io/deviceorientation/spec-source-orientation.html#deviceorientation\">deviceorientation</a> and <a href=\"https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html\">DeviceOrientationEvent</a> for details.\n<br/><a href=\"/examples/sensors\">example &raquo;</a></p>\n\n<iframe style=\"border:0;width:900px;height:300px\" src=\"/apps/docs/example#path=$sensors/gyroscope.js\"></iframe>\n\n\n<p><a target=\"blank\" href=\"/apps/docs/example#path=$sensors/gyroscope.js\">open example in new tab &raquo;</a></p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-attribute'>Attributes</h3><div class='subsection'><div id='attribute-accuracy' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-accuracy' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-accuracy' class='name expandable'>accuracy</a> : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>The compass accuracy, see https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/Devic...</div><div class='long'><p>The compass accuracy, see <a href=\"https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html\">https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html</a> for details.</p>\n<p>Defaults to: <code>&quot;0&quot;</code></p></div></div></div><div id='attribute-alpha' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-alpha' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-alpha' class='name expandable'>alpha</a> : typeless<span class=\"signature\"></span></div><div class='description'><div class='short'>Alias for the alpha component of orientation ...</div><div class='long'><p>Alias for the alpha component of orientation</p>\n<p>Defaults to: <code>&quot;undefined&quot;</code></p></div></div></div><div id='attribute-beta' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-beta' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-beta' class='name expandable'>beta</a> : typeless<span class=\"signature\"></span></div><div class='description'><div class='short'>Alias for the beta component of orientation ...</div><div class='long'><p>Alias for the beta component of orientation</p>\n<p>Defaults to: <code>&quot;undefined&quot;</code></p></div></div></div><div id='attribute-compass' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-compass' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-compass' class='name expandable'>compass</a> : Number<span class=\"signature\"></span></div><div class='description'><div class='short'>The compass orientation, see https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/De...</div><div class='long'><p>The compass orientation, see <a href=\"https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html\">https://developer.apple.com/library/safari/documentation/SafariDOMAdditions/Reference/DeviceOrientationEventClassRef/DeviceOrientationEvent/DeviceOrientationEvent.html</a> for details.</p>\n<p>Defaults to: <code>&quot;0&quot;</code></p></div></div></div><div id='attribute-gamma' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-gamma' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-gamma' class='name expandable'>gamma</a> : typeless<span class=\"signature\"></span></div><div class='description'><div class='short'>Alias for the gamma component of orientation ...</div><div class='long'><p>Alias for the gamma component of orientation</p>\n<p>Defaults to: <code>&quot;undefined&quot;</code></p></div></div></div><div id='attribute-orientation' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-orientation' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-orientation' class='name expandable'>orientation</a> : vec3<span class=\"signature\"></span></div><div class='description'><div class='short'>Three component (alpha, beta, gamma) orientation of the device ...</div><div class='long'><p>Three component (alpha, beta, gamma) orientation of the device</p>\n<p>Defaults to: <code>&quot;0,0,0&quot;</code></p></div></div></div><div id='attribute-supported' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='gyroscope'>gyroscope</span><br/><a href='source/gyroscope.html#gyroscope-attribute-supported' target='_blank' class='view-source'>view source</a></div><a href='#!/api/gyroscope-attribute-supported' class='name expandable'>supported</a> : Boolean<span class=\"signature\"></span></div><div class='description'><div class='short'>True if gyro is supported ...</div><div class='long'><p>True if gyro is supported</p>\n<p>Defaults to: <code>&quot;false&quot;</code></p></div></div></div></div></div><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-addListener' class='member first-child inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-addListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-addListener' class='name expandable'>addListener</a>( <span class='pre'>key, cb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>add a listener to an attribute ...</div><div class='long'><p>add a listener to an attribute</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>cb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-find' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-find' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-find' class='name expandable'>find</a>( <span class='pre'>name</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds a parent node by name. ...</div><div class='long'><p>Finds a parent node by name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-findChild' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-findChild' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-findChild' class='name expandable'>findChild</a>( <span class='pre'>name</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Finds a child node by name. ...</div><div class='long'><p>Finds a child node by name.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>name</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div><div id='method-mixin' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-mixin' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-mixin' class='name expandable'>mixin</a>( <span class='pre'></span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>Mixes in another class or object, just pass in any number of object or class references. ...</div><div class='long'><p>Mixes in another class or object, just pass in any number of object or class references. They are copied on key by key</p>\n</div></div></div><div id='method-removeListener' class='member  inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><a href='#!/api/node' rel='node' class='defined-in docClass'>node</a><br/><a href='source/node.html#node-method-removeListener' target='_blank' class='view-source'>view source</a></div><a href='#!/api/node-method-removeListener' class='name expandable'>removeListener</a>( <span class='pre'>key, cb</span> )<span class=\"signature\"></span></div><div class='description'><div class='short'>remove a listener from an attribute, uses the actual function reference to find it\nif you dont pass in a function ref...</div><div class='long'><p>remove a listener from an attribute, uses the actual function reference to find it\nif you dont pass in a function reference it removes all listeners</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>key</span> : Object<div class='sub-desc'>\n</div></li><li><span class='pre'>cb</span> : Object<div class='sub-desc'>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});